diff -crN nakedmudv1.0/src/list.c nakedmudv1.4/src/list.c
*** nakedmudv1.0/src/list.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/list.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,36 ****
  //*****************************************************************************
  //
! // list.c
  //
! // the implementation of a generic list structure
  //
  //*****************************************************************************
  
  #include <stdlib.h>
  #include "list.h"
  
  
  struct list_node {
!   void *elem;
!   struct list_node *next;
  };
  
  struct list_iterator {
!   struct list      *L;
!   struct list_node *curr;
  };
  
  struct list {
!   struct list_node *head;
!   struct list_node *tail;
!   int size;
  };
  
- #ifndef FALSE
- #define FALSE   0
- #define TRUE    !(FALSE)
- #endif
- 
  
  //
  // Delete a list node, and all nodes attached to it
--- 1,46 ----
  //*****************************************************************************
  //
! // list.c v1.1
  //
! // the implementation of a generic list structure.
! //
! // Jan 15/04:
! //   Removing elements from the list while we're iterating over it can be very
! // dangerous. The latest revision of the list keeps track of how many iterators
! // are currently running overtop of us, and only actually removes items from
! // the list until the iterator count goes down to 0; until then, the items are
! // flagged as removed so they are not touched.
  //
  //*****************************************************************************
  
  #include <stdlib.h>
  #include "list.h"
  
+ #ifndef FALSE
+ #define FALSE   0
+ #define TRUE    !(FALSE)
+ #endif
  
  struct list_node {
!   void *elem;              // the data we contain
!   struct list_node *next;  // the next node in the list
!   char removed;            // has the item been removed from the list? 
!                            // char == bool
  };
  
  struct list_iterator {
!   struct list      *L;     // the list we're iterating over
!   struct list_node *curr;  // the current element we're iterating on
  };
  
  struct list {
!   struct list_node *head;  // first element in the list
!   struct list_node *tail;  // last element in the list
!   int size;                // how many elements are in the list?
!   int iterators;           // how many iterators are going over us?
!   int remove_pending;      // do we have to do a remove when the iterators die?
  };
  
  
  //
  // Delete a list node, and all nodes attached to it
***************
*** 45,51 ****
  //
  void deleteListNodeWith(struct list_node *N, void (*delete_func)(void *)) {
    if(N->next) deleteListNodeWith(N->next, delete_func);
!   delete_func(N->elem);
    free(N);
  }
  
--- 55,63 ----
  //
  void deleteListNodeWith(struct list_node *N, void (*delete_func)(void *)) {
    if(N->next) deleteListNodeWith(N->next, delete_func);
!   // we only want to delete elements that are actually in the list
!   if(!N->removed)
!     delete_func(N->elem);
    free(N);
  }
  
***************
*** 54,65 ****
  //
  struct list_node *newListNode(void *elem) {
    struct list_node *N = malloc(sizeof(struct list_node));
!   N->elem = elem;
!   N->next = NULL;
    return N;
  };
  
  
  
  
  //*****************************************************************************
--- 66,123 ----
  //
  struct list_node *newListNode(void *elem) {
    struct list_node *N = malloc(sizeof(struct list_node));
!   N->elem    = elem;
!   N->next    = NULL;
!   N->removed = FALSE;
    return N;
  };
  
  
+ //
+ // take out all of the nodes that have been flagged as "removed"
+ // from the list.
+ //
+ void listCleanRemoved(struct list *L) {
+   // go through and kill all of the elements we removed if removes are pending
+   if(L->remove_pending) {
+     struct list_node *node = L->head;
+ 
+     // while our head is a removed element, 
+     // pop it off and delete the list node
+     while(node && node->removed) {
+       L->head = node->next;
+       node->next = NULL;
+       deleteListNode(node);
+       node = L->head;
+     }
+     
+     // go through the rest of the list
+     if(node != NULL) {
+       while(node->next != NULL) {
+ 	// is our next element to be removed?
+ 	if(node->next->removed) {
+ 	  struct list_node *removed = node->next;
+ 	  node->next = removed->next;
+ 	  removed->next = NULL;
+ 	  deleteListNode(removed);
+ 	  // if we just removed the last element in the list, our next 
+ 	  // node should be NULL and we cannot keep do our next loop, 
+ 	  // as we'll try to assign NULL to the current node
+ 	  if(node->next == NULL) break;
+ 	}
+ 	node = node->next;
+       }
+     }
+     
+     // reset the tail of our list
+     L->tail = node;
+     
+     // if we have no elements left, clear our head and tail
+     if(L->size == 0)
+       L->head = L->tail = NULL;
+   }
+ }
+ 
  
  
  //*****************************************************************************
***************
*** 68,77 ****
  //
  //*****************************************************************************
  struct list *newList() {
!   struct list *L = malloc(sizeof(struct list));
!   L->head = NULL;
!   L->tail = NULL;
!   L->size = 0;
    return L;
  };
  
--- 126,137 ----
  //
  //*****************************************************************************
  struct list *newList() {
!   struct list *L    = malloc(sizeof(struct list));
!   L->head           = NULL;
!   L->tail           = NULL;
!   L->size           = 0;
!   L->iterators      = 0;
!   L->remove_pending = FALSE;
    return L;
  };
  
***************
*** 94,100 ****
    N->next = L->head;
    L->head = N;
    L->size++;
!   if(L->size == 1)
      L->tail = N;
  };
  
--- 154,160 ----
    N->next = L->head;
    L->head = N;
    L->size++;
!   if(L->tail == NULL)
      L->tail = N;
  };
  
***************
*** 130,137 ****
  int listIn(struct list *L, const void *elem) {
    struct list_node *N = L->head;
  
!   while(N) {
!     if(N->elem == elem)
        return TRUE;
      N = N->next;
    }
--- 190,197 ----
  int listIn(struct list *L, const void *elem) {
    struct list_node *N = L->head;
  
!   while(N != NULL) {
!     if(!N->removed && N->elem == elem)
        return TRUE;
      N = N->next;
    }
***************
*** 148,175 ****
      return FALSE;
  
    // we first have to check if it is the head
!   if(N->elem == elem) {
!     L->head = N->next;
!     N->next = NULL;
!     deleteListNode(N);
!     L->size--;
!     if(L->size == 0)
!       L->tail = NULL;
!     return TRUE;
    }
    // otherwise, we can check if it's another element
    else {
      while(N->next) {
        // we found it ... remove it now
!       if(N->next->elem == elem) {
! 	if(N->next == L->tail)
! 	  L->tail = N;
! 	struct list_node *tmp = N->next;
! 	N->next = tmp->next;
! 	tmp->next = NULL;
! 	deleteListNode(tmp);
! 	L->size--;
! 	return TRUE;
        }
        N = N->next;
      }
--- 208,253 ----
      return FALSE;
  
    // we first have to check if it is the head
!   if(!N->removed && N->elem == elem) {
!     // check to see if there's an iterator on us
!     if(L->iterators > 0) {
!       N->removed = TRUE;
!       L->size--;
!       L->remove_pending = TRUE;
!       return TRUE;
!     }
!     else {
!       L->head = N->next;
!       N->next = NULL;
!       deleteListNode(N);
!       L->size--;
!       if(L->size == 0)
! 	L->tail = NULL;
!       return TRUE;
!     }
    }
    // otherwise, we can check if it's another element
    else {
      while(N->next) {
        // we found it ... remove it now
!       if(!N->next->removed && N->next->elem == elem) {
! 	// check to see if there's an iterator on us
! 	if(L->iterators > 0) {
! 	  N->next->removed = TRUE;
! 	  L->remove_pending = TRUE;
! 	  L->size--;
! 	  return TRUE;
! 	}
! 	else {
! 	  if(N->next == L->tail)
! 	    L->tail = N;
! 	  struct list_node *tmp = N->next;
! 	  N->next = tmp->next;
! 	  tmp->next = NULL;
! 	  deleteListNode(tmp);
! 	  L->size--;
! 	  return TRUE;
! 	}
        }
        N = N->next;
      }
***************
*** 192,255 ****
    struct list_node *node = L->head;
    int i;
  
!   for(i = 0; i < num && node; i++)
      node = node->next;
  
!   if(node) return node->elem;
!   else     return NULL;
  }
  
  int isListEmpty(struct list *L) {
!   return (L->head == NULL);
  }
  
  void *listGetWith(struct list *L, const void *cmpto, void *func) {
    int (* comparator)(const void *, const void *) = func;
    struct list_node *node = L->head;
  
!   for(node = L->head; node != NULL; node = node->next)
      if(!comparator(cmpto, node->elem))
        return node->elem;
    return NULL;
  }
  
! int listRemoveWith(struct list *L, const void *cmpto, void *func) {
    int (* comparator)(const void *, const void *) = func;
    struct list_node *N = L->head;
  
    // we don't have any contents
    if(N == NULL)
!     return FALSE;
  
    // we first have to check if it is the head
!   if(!comparator(cmpto, N->elem)) {
!     L->head = N->next;
!     N->next = NULL;
!     deleteListNode(N);
!     L->size--;
!     if(L->size == 0)
!       L->tail = NULL;
!     return TRUE;
    }
    // otherwise, we can check if it's another element
    else {
      while(N->next) {
        // we found it ... remove it now
!       if(!comparator(cmpto, N->next->elem)) {
! 	if(N->next == L->tail)
! 	  L->tail = N;
! 	struct list_node *tmp = N->next;
! 	N->next = tmp->next;
! 	tmp->next = NULL;
! 	deleteListNode(tmp);
! 	L->size--;
! 	return TRUE;
        }
        N = N->next;
      }
    }
    // we didn't find it
!   return FALSE;
  }
  
  
--- 270,363 ----
    struct list_node *node = L->head;
    int i;
  
!   // move up to our first non-removed node
!   while(node && node->removed)
      node = node->next;
  
!   for(i = 0; i < num && node; node = node->next) {
!     if(node->removed)
!       continue;
!     i++;
!   }
! 
!   return (node ? node->elem : NULL);
  }
  
  int isListEmpty(struct list *L) {
!   return (L->size == 0);
  }
  
  void *listGetWith(struct list *L, const void *cmpto, void *func) {
    int (* comparator)(const void *, const void *) = func;
    struct list_node *node = L->head;
  
!   for(node = L->head; node != NULL; node = node->next) {
!     if(node->removed)
!       continue;
      if(!comparator(cmpto, node->elem))
        return node->elem;
+   }
    return NULL;
  }
  
! void *listRemoveWith(struct list *L, const void *cmpto, void *func) {
    int (* comparator)(const void *, const void *) = func;
    struct list_node *N = L->head;
  
    // we don't have any contents
    if(N == NULL)
!     return NULL;
  
    // we first have to check if it is the head
!   if(!N->removed && !comparator(cmpto, N->elem)) {
!     // check to see if there's an iterator on us
!     if(L->iterators > 0) {
!       N->removed = TRUE;
!       L->remove_pending = TRUE;
!       L->size--;
!       return N->elem;
!     }
!     else {
!       void *elem = N->elem;
!       L->head = N->next;
!       N->next = NULL;
!       deleteListNode(N);
!       L->size--;
!       if(L->size == 0)
! 	L->tail = NULL;
!       return elem;
!     }
    }
+ 
    // otherwise, we can check if it's another element
    else {
      while(N->next) {
        // we found it ... remove it now
!       if(!N->next->removed && !comparator(cmpto, N->next->elem)) {
! 	// check to see if there's an iterator on us
! 	if(L->iterators > 0) {
! 	  N->next->removed = TRUE;
! 	  L->remove_pending = TRUE;
! 	  L->size--;
! 	  return N->next->elem;
! 	}
! 	else {
! 	  void *elem = N->next->elem;
! 	  if(N->next == L->tail)
! 	    L->tail = N;
! 	  struct list_node *tmp = N->next;
! 	  N->next = tmp->next;
! 	  tmp->next = NULL;
! 	  deleteListNode(tmp);
! 	  L->size--;
! 	  return elem;
! 	}
        }
        N = N->next;
      }
    }
    // we didn't find it
!   return NULL;
  }
  
  
***************
*** 259,282 ****
  
    // we don't have any contents, or we're lower than the
    // first list content then just put it at the start
!   if(N == NULL || comparator(elem, N->elem) < 0)
      listPut(L, elem);
    else {
      // while we've got a next element, compare ourselves to it.
      // if we are smaller than it, then sneak inbetween. Otherwise,
      // skip to the next element
      while(N->next != NULL) {
!       int val = comparator(elem, N->next->elem);
!       // we're less than or equal to it... sneak in
!       if(val <= 0) {
! 	struct list_node *new_node = newListNode(elem);
! 	new_node->next = N->next;
! 	N->next = new_node;
! 	L->size++;
! 	return;
        }
!       else
! 	N = N->next;
      }
      // if we've gotten this far, then we need to attach ourself to the end
      N->next = newListNode(elem);
--- 367,391 ----
  
    // we don't have any contents, or we're lower than the
    // first list content then just put it at the start
!   if(N == NULL || (!N->removed && comparator(elem, N->elem) < 0))
      listPut(L, elem);
    else {
      // while we've got a next element, compare ourselves to it.
      // if we are smaller than it, then sneak inbetween. Otherwise,
      // skip to the next element
      while(N->next != NULL) {
!       if(!N->next->removed) {
! 	int val = comparator(elem, N->next->elem);
! 	// we're less than or equal to it... sneak in
! 	if(val <= 0) {
! 	  struct list_node *new_node = newListNode(elem);
! 	  new_node->next = N->next;
! 	  N->next = new_node;
! 	  L->size++;
! 	  return;
! 	}
        }
!       N = N->next;
      }
      // if we've gotten this far, then we need to attach ourself to the end
      N->next = newListNode(elem);
***************
*** 294,299 ****
--- 403,411 ----
    while(listSize(L) > 0)
      listPutWith(new_list, listPop(L), func);
  
+   // kill all of our removed nodes
+   if(L->head) deleteListNode(L->head);
+ 
    L->head = new_list->head;
    L->tail = new_list->tail;
    L->size = new_list->size;
***************
*** 308,315 ****
    struct list *newlist = newList();
  
    struct list_node *N = NULL;
!   for(N = L->head; N; N = N->next)
      listQueue(newlist, copy_func(N->elem));
  
    return newlist;
  }
--- 420,429 ----
    struct list *newlist = newList();
  
    struct list_node *N = NULL;
!   for(N = L->head; N; N = N->next) {
!     if(N->removed) continue;
      listQueue(newlist, copy_func(N->elem));
+   }
  
    return newlist;
  }
***************
*** 324,333 ****
--- 438,452 ----
    struct list_iterator *I = malloc(sizeof(struct list_iterator));
    I->L    = L;
    I->curr = I->L->head;
+   L->iterators++;
    return I;
  };
  
  void deleteListIterator(struct list_iterator *I) {
+   I->L->iterators--;
+   // if we're at 0 iterators, clean the list of all removed elements
+   if(I->L->iterators == 0)
+     listCleanRemoved(I->L);
    free(I);
  };
  
***************
*** 335,353 ****
    if(I->curr)
      I->curr = I->curr->next;
  
!   if(I->curr)
!     return I->curr->elem;
!   else        
!     return NULL;
  };
  
  void listIteratorReset(struct list_iterator *I) {
    I->curr = I->L->head;
  };
  
  void *listIteratorCurrent(struct list_iterator *I) {
!   if(I->curr)
!     return I->curr->elem;
!   else
!     return NULL;
  };
--- 454,480 ----
    if(I->curr)
      I->curr = I->curr->next;
  
!   // skip all of the removed elements
!   while(I->curr && I->curr->removed)
!     I->curr = I->curr->next;
! 
!   return (I->curr ? I->curr->elem : NULL);
  };
  
+ // hmmm... we should really kill this function. 
+ // Just let 'em create a new iterator
  void listIteratorReset(struct list_iterator *I) {
+   // if we're the only iterator, take this opportunity to clean the list
+   if(I->L->iterators == 1)
+     listCleanRemoved(I->L);
+ 
    I->curr = I->L->head;
  };
  
  void *listIteratorCurrent(struct list_iterator *I) {
!   // hmmm... what if we're on a removed node?
!   while(I->curr && I->curr->removed)
!     I->curr = I->curr->next;
! 
!   return (I->curr ? I->curr->elem : NULL);
  };
diff -crN nakedmudv1.0/src/list.h nakedmudv1.4/src/list.h
*** nakedmudv1.0/src/list.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/list.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 115,121 ****
  // TRUE if the item was found and removed. FALSE other wise. Cmpto must
  // be the thing we are compared against in func.
  //
! int listRemoveWith(struct list *L, const void *cmpto, void *func);
  
  
  //
--- 115,121 ----
  // TRUE if the item was found and removed. FALSE other wise. Cmpto must
  // be the thing we are compared against in func.
  //
! void *listRemoveWith(struct list *L, const void *cmpto, void *func);
  
  
  //
diff -crN nakedmudv1.0/src/log.c nakedmudv1.4/src/log.c
*** nakedmudv1.0/src/log.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/log.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 99,105 ****
    }
  
    add_cmd("log", NULL, cmd_log, 0, POS_UNCONCIOUS, POS_FLYING,
! 	  LEVEL_ADMIN, FALSE);
  }
  
  
--- 99,105 ----
    }
  
    add_cmd("log", NULL, cmd_log, 0, POS_UNCONCIOUS, POS_FLYING,
! 	  LEVEL_ADMIN, FALSE, FALSE);
  }
  
  
diff -crN nakedmudv1.0/src/main.mk nakedmudv1.4/src/main.mk
*** nakedmudv1.0/src/main.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/main.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,13 ----
+ SRC    += gameloop.c mud.c utils.c interpret.c handler.c inform.c movement.c \
+ 	  action.c mccp.c save.c socket.c io.c strings.c event.c \
+ 	  \
+ 	  cmd_comm.c cmd_manip.c cmd_misc.c \
+ 	  \
+ 	  text_editor.c builder.c admin.c \
+ 	  \
+ 	  items.c races.c log.c help.c auxiliary.c \
+ 	  \
+ 	  world.c character.c room.c exit.c extra_descs.c object.c body.c \
+ 	  zone.c dialog.c room_reset.c \
+ 	  \
+ 	  list.c property_table.c hashtable.c hashmap.c storage.c
diff -crN nakedmudv1.0/src/Makefile nakedmudv1.4/src/Makefile
*** nakedmudv1.0/src/Makefile	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/Makefile	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,51 ****
  ###############################################################################
! #Makefile for nakedmud
  ###############################################################################
  
  # compiler to use
  CC = gcc
  
! 
! ################################################################################
! #
! # Libraries and compile-time flags
! #
! ################################################################################
  
  # flags to use during compilation
! C_FLAGS = -Wall -g -ggdb -O2
  
! # libraries
! L_FLAGS = -lz -lpthread
  
! # linking requirements for the python scripting module. See
! # src/modules/scripts/makefile
! L_PY     = -u __dummy -u _PyMac_Error -framework Python -framework System \
! 	   -framework CoreServices -framework Foundation
! 
! # the location of the Python .a file, if it is needed. See 
! # src/modules/scripts/Makefile
! PY_LIB   =
  
! 
! ################################################################################
! #
! # object files, and source files for python extentions
! #
! ################################################################################
! O_FILES = gameloop.o mud.o utils.o interpret.o handler.o inform.o movement.o \
! 	  action.o mccp.o save.o socket.o io.o strings.o event.o \
! 	  \
! 	  cmd_comm.o cmd_manip.o cmd_misc.o \
! 	  \
! 	  text_editor.o builder.o admin.o \
! 	  \
! 	  items.o races.o log.o help.o auxiliary.o \
! 	  \
! 	  world.o character.o room.o exit.o extra_descs.o object.o body.o \
! 	  zone.o dialog.o room_reset.o \
! 	  \
! 	  list.o property_table.o hashtable.o hashmap.o storage.o
  
  
  
--- 1,49 ----
  ###############################################################################
! # Makefile for nakedmud
! #
! # Many thanks go out to Tyche for suggesting I read "Recursive Make Considered
! # Harmful" by Peter Miller. Many of the make conventions used in this makefile
! # were taken from Miller's article. The reference is:
! # 
! # Miller, P.A. (1998). Recursive Make Considered Harmful,
! #    AUUGN Journal of AUUG Inc., 19(1), pp. 14-25.
! #
  ###############################################################################
  
  # compiler to use
  CC = gcc
  
! # the modules we have installed
! MODULES := time alias char_vars socials olc scripts
  
  # flags to use during compilation
! C_FLAGS := -Wall -g -ggdb -O2
  
! # extra libraries if required
! LIBS    := -lz -lpthread -lcrypt
  
! # each module will add to this from its module.mk file
! SRC     := gameloop.c mud.c utils.c interpret.c handler.c inform.c movement.c \
! 	   action.c mccp.c save.c socket.c io.c strings.c event.c \
! 	   \
! 	   cmd_comm.c cmd_manip.c cmd_misc.c \
! 	   \
! 	   text_editor.c builder.c admin.c help.c \
! 	   \
! 	   items.c races.c log.c auxiliary.c \
! 	   \
! 	   world.c character.c room.c exit.c extra_descs.c object.c body.c \
! 	   zone.c dialog.c room_reset.c \
! 	   \
! 	   list.c property_table.c hashtable.c hashmap.c storage.c
! 
! 
! # include the description for each module. These will add to SRC
! # C_FLAGS, LIBS, etc...
! include $(patsubst %,%/module.mk, $(MODULES))
  
! # determine the object files
! O_FILES := $(patsubst %.c,%.o, $(filter %.c, $(SRC)))
  
  
  
***************
*** 55,106 ****
  #
  ################################################################################
  all: $(O_FILES)
! 	make module
! 	rm -f NakedMud
! 	$(CC) -o NakedMud *.o $(PY_LIB) $(L_FLAGS) $(L_PY)
  
! # make the object files
  .c.o: all
! 	$(CC) -c $(C_FLAGS) $<
  
  # make dependancies for all of the files
  depend:
! 	$(CC) -MM *.c > .depend
! 	make moduledepend
  
  clean:
- 	rm -f *.o
- 	rm -f *.o
- 	make moduleclean
  	rm -f NakedMud
! 	rm -f *.*~
! 
  
  include .depend
- 
- 
- ################################################################################
- #
- # when installing new modules, you will need to add the name of your module
- # to the MODULES list
- #
- ################################################################################
- MODULES = time olc scripts
- 
- # compile all of the modules we have installed
- module:
- 	for dir in $(MODULES); do             \
- 	  (cd modules/$$dir; $(MAKE) all);    \
- 	done
- 
- # clean all of our modules out
- moduleclean:
- 	for dir in $(MODULES); do             \
- 	  (cd modules/$$dir; $(MAKE) clean);  \
- 	done
- 
- # make dependancies for all of our modules
- moduledepend:
- 	for dir in $(MODULES); do             \
- 	  (cd modules/$$dir; $(MAKE) depend); \
- 	done
--- 53,80 ----
  #
  ################################################################################
  all: $(O_FILES)
! 	$(CC) -o NakedMud $(O_FILES) $(LIBS)
  
! # make the object files. The modules are sort of annoying, in that 
! # if we do not use -o, the object files will be compiled in this directory,
! # and then every time we re-make, the module .o files will be recompiled
! # because they are not in their home directory. So... we have to explicitly
! # say where the .o files need to go
  .c.o: all
! 	$(CC) -c $(C_FLAGS) -o $(patsubst %.c,%.o, $<) $<
! #	$(CC) -c $(C_FLAGS) $<
! 
  
  # make dependancies for all of the files
  depend:
! 	$(CC) -MM $(filter %.c, $(SRC)) > .depend
  
+ # clear all of the .o files and all of the save files that emacs makes
  clean:
  	rm -f NakedMud
! 	rm -f *.o
! 	rm -f */*.o
! 	rm -f *~
! 	rm -f */*~
  
  include .depend
diff -crN nakedmudv1.0/src/movement.c nakedmudv1.4/src/movement.c
*** nakedmudv1.0/src/movement.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/movement.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 21,27 ****
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "modules/scripts/script.h"
  #endif
  
  
--- 21,27 ----
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "scripts/script.h"
  #endif
  
  
***************
*** 39,49 ****
        message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
  	      exitGetSpecLeave(exit));
      else if(dir != DIR_NONE)
!       message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
! 	      "$n leaves %s.", dirGetName(dir));
      else
!       message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
! 	      "$n leaves.");
  
      char_from_room(ch);
      char_to_room(ch, to);
--- 39,48 ----
        message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
  	      exitGetSpecLeave(exit));
      else if(dir != DIR_NONE)
!       send_around_char(ch, TRUE, "%s leaves %s.\r\n",
! 		       charGetName(ch), dirGetName(dir));
      else
!       send_around_char(ch, TRUE, "%s leaves.\r\n", charGetName(ch));
  
      char_from_room(ch);
      char_to_room(ch, to);
***************
*** 53,63 ****
        message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
  	      exitGetSpecEnter(exit));
      else if(dir != DIR_NONE)
!       message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
! 	      "$n arrives from the %s.", dirGetName(dirGetOpposite(dir)));
      else
!       message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
! 	      "$n has arrived.");
  
      return TRUE;
    }
--- 52,61 ----
        message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
  	      exitGetSpecEnter(exit));
      else if(dir != DIR_NONE)
!       send_around_char(ch, TRUE, "%s arrives from the %s.\r\n",
! 		       charGetName(ch), dirGetName(dirGetOpposite(dir)));
      else
!       send_around_char(ch, TRUE, "%s has arrived.\r\n", charGetName(ch));
  
      return TRUE;
    }
***************
*** 175,183 ****
    }
    else {
      send_to_char(ch, "You %s.\r\n", posGetActionSelf(pos));
      charSetPos(ch, pos);
-     message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
- 	    "$n %s.", posGetActionOther(pos));
      return TRUE;
    }
  }
--- 173,181 ----
    }
    else {
      send_to_char(ch, "You %s.\r\n", posGetActionSelf(pos));
+     send_around_char(ch, TRUE, "%s %s.\r\n", 
+ 		     charGetName(ch), posGetActionOther(pos));
      charSetPos(ch, pos);
      return TRUE;
    }
  }
***************
*** 188,200 ****
    strip_word(arg, "at");
    strip_word(arg, "on");
  
-   int furniture_type  = FOUND_NONE;
    OBJ_DATA *furniture = generic_find(ch, arg,
  				     FIND_TYPE_OBJ, 
  				     FIND_SCOPE_ROOM | FIND_SCOPE_VISIBLE,
! 				     FALSE, &furniture_type);
    
!   if(!furniture || furniture_type != FOUND_OBJ)
      send_to_char(ch, "Where did you want to %s?\r\n", posGetActionSelf(pos));
    else if(objGetType(furniture) != ITEM_FURNITURE)
      send_to_char(ch, "But that's not furniture!\r\n");
--- 186,197 ----
    strip_word(arg, "at");
    strip_word(arg, "on");
  
    OBJ_DATA *furniture = generic_find(ch, arg,
  				     FIND_TYPE_OBJ, 
  				     FIND_SCOPE_ROOM | FIND_SCOPE_VISIBLE,
! 				     FALSE, NULL);
    
!   if(furniture == NULL)
      send_to_char(ch, "Where did you want to %s?\r\n", posGetActionSelf(pos));
    else if(objGetType(furniture) != ITEM_FURNITURE)
      send_to_char(ch, "But that's not furniture!\r\n");
***************
*** 216,231 ****
  	      "$n stands up from $o.");
        char_from_furniture(ch);
      }
!     
!     // now sit down on the new thing
      send_to_char(ch, "You %s %s %s.\r\n",
  		 posGetActionSelf(pos),
  		 (objGetSubtype(furniture) == FURNITURE_ON ? "on" : "at"),
  		 objGetName(furniture));
!     message(ch, NULL, furniture, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
! 	    "$n %s %s $o.",
! 	    posGetActionOther(pos),
! 	    (objGetSubtype(furniture) == FURNITURE_ON ? "on" : "at"));
      char_to_furniture(ch, furniture);
      charSetPos(ch, pos);
      return TRUE;
--- 213,232 ----
  	      "$n stands up from $o.");
        char_from_furniture(ch);
      }
! 
!     // send out messages
!     char other_buf[SMALL_BUFFER];
!     sprintf(other_buf, "$n %s %s $o.",	
! 	    posGetActionOther(pos),
! 	    (objGetSubtype(furniture) == FURNITURE_ON ? "on" : "at"));
!     message(ch, NULL, furniture, NULL, TRUE, TO_ROOM | TO_NOTCHAR, other_buf);
! 
      send_to_char(ch, "You %s %s %s.\r\n",
  		 posGetActionSelf(pos),
  		 (objGetSubtype(furniture) == FURNITURE_ON ? "on" : "at"),
  		 objGetName(furniture));
! 
!     // now sit down on the new thing
      char_to_furniture(ch, furniture);
      charSetPos(ch, pos);
      return TRUE;
***************
*** 251,258 ****
  COMMAND(cmd_stand) {
    if(charGetPos(ch) == POS_FLYING) {
      send_to_char(ch, "You stop flying.\r\n");
!     message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
! 	    "$n stops flying.");
      charSetPos(ch, POS_STANDING);
    }
    else {
--- 252,258 ----
  COMMAND(cmd_stand) {
    if(charGetPos(ch) == POS_FLYING) {
      send_to_char(ch, "You stop flying.\r\n");
!     send_around_char(ch, TRUE, "%s stops flying.\r\n", charGetName(ch));
      charSetPos(ch, POS_STANDING);
    }
    else {
***************
*** 263,269 ****
  
  COMMAND(cmd_wake) {
    send_to_char(ch, "You stop sleeping and sit up.\r\n");
!   message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
! 	  "$n stops sleeping and sits up.");
    charSetPos(ch, POS_SITTING);
  }
--- 263,269 ----
  
  COMMAND(cmd_wake) {
    send_to_char(ch, "You stop sleeping and sit up.\r\n");
!   send_around_char(ch, TRUE, "%s stops sleeping and sits up.\r\n",
! 		   charGetName(ch));
    charSetPos(ch, POS_SITTING);
  }
